#!/bin/bash

# -------------------------------------------------------------------------- #
# Copyright 2002-2010, OpenNebula Project Leads (OpenNebula.org)             #
#                                                                            #
# Licensed under the Apache License, Version 2.0 (the "License"); you may    #
# not use this file except in compliance with the License. You may obtain    #
# a copy of the License at                                                   #
#                                                                            #
# http://www.apache.org/licenses/LICENSE-2.0                                 #
#                                                                            #
# Unless required by applicable law or agreed to in writing, software        #
# distributed under the License is distributed on an "AS IS" BASIS,          #
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   #
# See the License for the specific language governing permissions and        #
# limitations under the License.                                             #
#--------------------------------------------------------------------------- #

# -------------------------------------------------------------------------- #
# Copyright (C) 2011 Politecnico di Torino, Italy                            #
#                    TORSEC group -- http://security.polito.it               #
#                                                                            #
# Author: Roberto Sassu <roberto.sassu@polito.it>                            #
#                                                                            #
# This program is free software; you can redistribute it and/or modify       #
# it under the terms of the GNU General Public License as published by       #
# the Free Software Foundation, version 2 of the License.                    #
#--------------------------------------------------------------------------- #


SRC=$1
DST=$2

if [ -z "${ONE_LOCATION}" ]; then
    TMCOMMON=/usr/lib/one/mads/tm_common.sh
    LVMRC=/etc/one/tm_sharedlvm/tm_lvmrc
else
    TMCOMMON=$ONE_LOCATION/lib/mads/tm_common.sh
    LVMRC=$ONE_LOCATION/etc/tm_sharedlvm/tm_lvmrc
fi

. $TMCOMMON
. $LVMRC

SRC_PATH=`arg_path $SRC`
SRC_HOST=`arg_host $SRC`

log "SRC_PATH: $SRC_PATH"
VID=`get_vid $SRC_PATH`

log "Deleting remote LVs"
sleep 2

exec_and_log "$SUDO $LVREMOVE -f $(echo $VG_NAME/$($SUDO $LVS --noheadings $VG_NAME|$AWK '{print $1}'|grep lv-one-$VID))"

if [ "$SRC_HOST" != "$HOSTNAME" ]; then
	log "Updating LVM configuration on $SRC_HOST"
	CMD="lvscan"
	$SSH $DST_HOST $SUDO $CMD
	log "Executed \"$CMD\"."
	echo "
		A=\$(for i in \$($SUDO $LVS --noheadings | $AWK '\$2~/$VG_NAME/ {print \$1}' ); do echo $VG_NAME-\$(echo \$i | sed 's/-/--/g'); done)
		for i in \$($SUDO dmsetup -c info -o name --noheadings); do
			if [ \$(expr match \$i $VG_NAME) -eq 0 ]; then
				continue
			fi
			remove=1
			for j in \$A; do
				if [  \$(expr match \$i \$j) -ne 0 ] ; then
					remove=0
					break
				fi
			done
			if [ \$remove -eq 1 ]; then
				B=\"\$B \$i\"
			fi
		done
		C=\$(for i in \$B; do echo \$i; done | sort)
		for i in \$C; do
			$SUDO dmsetup remove \$i
		done" | $SSH $SRC_HOST "$BASH -s"

	[ "$?" != "0" ] && log_error "Error updating LVM configuration"
fi


log "Deleting $SRC_PATH"
exec_and_log "rm -rf $SRC_PATH"
